=== debian/changelog ===
facter (3.10.0-4) unstable; urgency=medium

  * Make facter compatible with RapidJSON 1.1 (Closes: #893351)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 19 Mar 2018 14:26:24 +0200

facter (3.10.0-3) unstable; urgency=medium

  * Upload to unstable
  * d/NEWS: document breaking changes

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 05 Mar 2018 23:22:11 +0200

facter (3.10.0-2) experimental; urgency=medium

  * Do not run the smoke test on build. Fixes FTBFS due to missing /proc in
    our buildds.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sat, 03 Mar 2018 15:21:22 +0200

facter (3.10.0-1) experimental; urgency=medium

  * New upstream release (Closes: #869763). This is a major update with
    possibly breaking changes, see
    https://docs.puppet.com/facter/3.0/release_notes.html and
    subsequent versions' release notes for more information.
    + Adjust Build-Depends
    + Drop facter 2.x patches
    + d/control: update description to reflect Facter 3.x
  * Upload to experimental
  * Split facter into facter, libfacterX.Y.Z and facter-dev
    + Mark library packages as Multi-Arch: same
  * Add ruby autopkgtests
  * Add puppet integration autopkgtests
  * B-D on ruby-dev-all and make libfacter available to all supported ruby
    versions
  * d/watch: look for facter 3 and switch url to https://
  * New upstream signing key (0x7F438280EF8D349F)
  * Switch Vcs-* URLs to salsa.d.o
  * Update homepage
  * Update d/copyright; this is a complete rewrite of the facter source.
  * d/rules: refactor
  * d/control: facter is now Architecture: any
  * New patch:
    + Use a shared cpp-hocon library
  * d/control: drop all of facter's Depends
  * Bump dh compat to 11; no changes needed
  * Bump Standards-Version to 4.1.3; no changes needed
  * Add myself to Uploaders
  * Remove Nigel from Uploaders; thanks for your work!

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 02 Mar 2018 14:23:49 +0200
