=== debian/control ===
Source: facter
Section: admin
Priority: optional
Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
Uploaders:
 Andrew Pollock <apollock@debian.org>,
 Micah Anderson <micah@debian.org>,
 Stig Sandbeck Mathisen <ssm@debian.org>,
 Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends:
 debhelper (>= 11),
 cmake,
 catch,
 libblkid-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-date-time-dev,
 libboost-regex-dev,
 libboost-thread-dev,
 libboost-chrono-dev,
 libboost-locale-dev,
 libboost-log-dev,
 libleatherman-dev,
 libcpp-hocon-dev,
 libcurl4-openssl-dev,
 libyaml-cpp-dev,
 libssl-dev,
 rapidjson-dev,
 ruby-all-dev,
Standards-Version: 4.1.3
Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
Vcs-Browser: https://salsa.debian.org/puppet-team/facter
Homepage: https://github.com/puppetlabs/facter

Package: facter
Architecture: any
Depends: libfacter3.10.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: collect and display facts about the system
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains the facter binary and the ruby module making facter
 available to Puppet.

Package: libfacter3.10.0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: collect and display facts about the system -- shared library
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains the core shared library implementing most of Facter's
 functionality.

Package: facter-dev
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: collect and display facts about the system -- development files
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains development files allowing 3rd party applications to use
 facter.
