=== debian/changelog ===
facter (3.11.0-4) unstable; urgency=medium

  * Team upload
  * Fix autopkgtest: ignore output on stderr (Closes: #955582)

 -- Utkarsh Gupta <utkarsh@debian.org>  Sun, 05 Apr 2020 21:36:26 +0530

facter (3.11.0-3) unstable; urgency=medium

  * Convert d/patches to gbp-pq layout
  * Fix parsing of Linux route non-kv flags (e.g. onlink) (Closes: #918250)
  * Bump Standards-Version to 4.4.0; no changes needed
  * Bump dh compat to 12; no changes needed

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Wed, 17 Jul 2019 11:54:37 -0300

facter (3.11.0-2) unstable; urgency=medium

  * Acknowledge 3.11.0-1.1 NMU. Thanks to gregor herrmann!
  * B-D on ruby (Closes: #897556)
  * Do not allow unsuitable custom facts to override built-in facts
    (Closes: #926197)
  * Bump Standards-Version to 4.3.0; no changes needed

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Tue, 02 Apr 2019 14:24:17 +0300

facter (3.11.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "missing Depends: libfacter3.11.0 (= ${binary:Version})":
    add the Depends, as suggested by Andreas Beckmann.
    (Closes: #906187)

 -- gregor herrmann <gregoa@debian.org>  Sat, 01 Dec 2018 00:19:32 +0100

facter (3.11.0-1) unstable; urgency=medium

  * New upstream release
    + Refresh patches
    + Rename libfacter3.10.0 to libfacter3.11.0

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 29 Mar 2018 13:13:41 +0300
