=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  Stig Sandbeck Mathisen <ssm@debian.org>,
  Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper (>= 12),
  cmake,
  catch,
  libblkid-dev,
@@ -28,14 +28,15 @@
  libssl-dev,
  rapidjson-dev,
  ruby-all-dev,
-Standards-Version: 4.1.3
+ ruby,
+Standards-Version: 4.4.0
 Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
 Vcs-Browser: https://salsa.debian.org/puppet-team/facter
 Homepage: https://github.com/puppetlabs/facter
 
 Package: facter
 Architecture: any
-Depends: libfacter3.10.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libfacter3.11.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: collect and display facts about the system
  Facter is Puppet’s cross-platform system profiling library. It discovers and
  reports per-node facts, which are collected by the Puppet agent and are made
@@ -50,7 +51,7 @@
  This package contains the facter binary and the ruby module making facter
  available to Puppet.
 
-Package: libfacter3.10.0
+Package: libfacter3.11.0
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -72,7 +73,7 @@
 Package: facter-dev
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, libfacter3.11.0 (= ${binary:Version})
 Description: collect and display facts about the system -- development files
  Facter is Puppet’s cross-platform system profiling library. It discovers and
  reports per-node facts, which are collected by the Puppet agent and are made
